/*********************************************************************
 * [htmldatɕϊ] pattern.js
 *  CuAdoEnums.js K{
 *
 * p^[ΉTCg
 *     2chnull : Qʂi2chnull.infoj
 *     logmemo : O߂ilogmemo.orgj
 *     logsoku : Oilogsoku.comj
 *     mimizun : ݂݂񌟍imimizun.comj
 *     unkar   : unkariunkar.orgj
 *     viva2ch : Viva2chiviva2ch.netj
 *
 * ΉĂƌĂAKɂEXbhŃeXg
 *   ł͑̂܂Ă悤AƂxB擾
 *   Ă󋵂قȂƎv̂ŁAeł̌؂͕KvłB
 *   e{TCgɂāAHTMLɂȂiKŊdat̏
 *   ĂꍇAȂƐmȕ͕s\łB
 *   ڍׂ͊ep^[̃RgQƂĂB
 *
 * ȉ̃TCǵAvOłdatɂ͕ssȓê߁A
 * Ή\͂܂B
 *     fXNgbv2chidesktop2ch.orgj
 *
 * 2012/09/24 VK쐬
 * 2012/09/28 2chnullAlogmemoAlogsokuAmimizunAunkar̃p^[Lڊ
 * 2012/10/06 viva2ch̃p^[ǉ
 * -------------------------------------------------------------------
 * Copyright(C) 2012 ASANO Sei (http://sei.qee.jp/docs/)
 *********************************************************************/
var patternInfo = {
	dummy : null
	/*---------------------------------------------------------------*
	 * Viva2chHTMLpp^[
	 *
	 * 2012/10/6݁Aȉ̖̂邱ƂĂ܂B
	 *
	 * 1)gbvzXg̑Oɕt</b>`<b>^O폜
	 *   ܂BŎn܂Έȍ~͑ł͂ȂƂ߂ł܂Ayz
	 *   ͂܂Ă镶zXgȂǂ̓[Uɂ͂ƋʂłA
	 *   ̂܂܉HɎgp邱Ƃɂ܂B
	 *---------------------------------------------------------------*/
	, viva2ch : {
		charset : adoEnums.streamCharset.UTF8
		, lineSeparator : adoEnums.lineSeparators.adLF
		//Xbh̔ƃXԍ擾pB̂̃YoȂ̂ŁÃN璊oB
		//<div id="pager"><div>`<a href="//Xԍ.html" `>`</a></div></div>
		//1:A2:Xbhԍ
		, source : {
			name : 'Xbh̔ƃXԍ'
			, pattern : /<div id="pager"><div>.+<a href="\/([a-z0-9]+)\/(\d+)\.html"\s.+>.+<\/a><\/div><\/div>/
			, number : ['$1', '$2'] //ɁAAXbhԍ
		}
		//^CgB̂̃YoȂ̂ŁA͂ĂȃubN}[Nւ̃N璊oB1:^CgB
		//data-hatena-bookmark-title="{^Cg}"
		, title : {
			name : 'Xbh^Cg'
			, pattern : /data\-hatena\-bookmark\-title="\{(.+?)\}"/ //"
			, number : ['$1'] //^Cg
		}
		//X̊JnwB̃p^[XQƌȂB
		//<ul id="res">`
		, resStart : {
			name : 'X̊Jnw'
			, pattern : /<ul id="res">/
		}
		//X̏I[wB̃p^[OXQƌȂB
		//<ul id="category">
		, resEnd : {
			name : 'X̏Iw'
			, pattern : /<ul id="category">/
		}
		//XbhOւ̃Nꊇ폜pB1:IWiURL
		//<a href="http://example.jp/"Cӂ̕>http://example.jp</a>
		, outerLink : {
			pattern : /<a href="[^#][^"]+"(?:[^>])*>([^<]+)<\/a>/g //"
			, after : '$1' //IWiURL
		}
		//Xbh̃AJ[ꊇupB$1:pL(2)A$2:X͈͔ԍ
		//uOF<a href="#Xԍ">&gt;&gt;Xԍ͈</a> &gt;̏ꍇ̓AJ[Ȃ
		//uF<a href="../test/read.cgi//Xbhԍ/X͈͔ԍ" target="_blank">
		, innerLink : {
			pattern : /<a href="#[^"]+">((?:&gt;){2})((?:\d+)?(?:\-\d+)?)<\/a>/g //"
			, after : '\/$2" target="_blank">$1$2<\/a>' //Xbhԍ܂ł̓vOőgݗĂ̂ŕsv
		}
		//XQ̏ɓÖꊇup
		, beforeResGroup : [
			//resEndōiݎwłȂA̗]ȕ폜
			{ pattern : /<\/ul><\/div>.*<\/h3>$/, after : '' }
			//L폜
			//<cite `>`</cite>
			, { pattern : /<cite.*?>.*?<\/cite>/g, after : '' }
			//<br /><br>ɕϊ
			, { pattern : /<br \/>/g, after : '<br>' }
		]
		//Xwb_̑SeB1:<dt></dt>̊Ԃ̓e
		//<dl id="resXԍ"><dt>`</dt>
		, resHeaderContent : {
			name : 'Xwb_̓e'
			, pattern : /<li>(.*?)<p>/ //"
			, number : ['$1'] //<li>`<p>̊Ԃ̓eidt^Ô͊܂܂Ȃj
		}
		//Xwb_̍זځB1:XԍA2:a^OA3:[
		//                  4:OAp^[E:tiIDABE܂ށj
		/*
		 OA[̃p^[͂Ƃ肠ꂾmFBtAIDABE𕪊AȂꍇ͕tȂ炵B
			<a name="99">99</a><span>O []</span><span>t</span><span>ID</span><span>BE</span>
			<a name="99">99</a><span>O [sage]</span><span>t</span>
		 Ӂ
		 Gcȕmain.jsőΉBID̂ȂIDȂƂʂłȂ̂ŁA
		 @Ƃ͈ꗥɏ̂ł͂ȂAdat蓮ŕҏWقB
		 */
		, resHeaderItem : {
			name : 'Xwb_̍ז'
			, pattern : /<a name="\d+">(\d{1,4})<\/a><span>(.*?) \[([^<]*)\]<\/span>/
			, number : ['$1', '$2', '$3', 'rightContext'] //ɁAXԍAOA[AtiIDABEAspan^O܂ށj
		}
		//X{
		/*
		 Ӂ
		 ̎QƂGXP[vĂ܂Ă炵ȂΉ͂ĂȂB
		 */
		, resBody : {
			name : 'X{'
			, pattern : /(.*?)<\/p><\/li>/
			, number : ['$1'] //wb_̒`</p></li>̊Ԃ̓eidd^Ô͊܂܂Ȃj
		}
	}
	/*---------------------------------------------------------------*
	 * O߂HTMLpp^[
	 *
	 * 2012/9/28݁Aȉ̖̂邱ƂĂ܂B
	 *
	 * 1)IWĩXURL`hĂĂAhĕ\
	 *   炵BIWiłURL\LɊւ͎cĂȂ߁A
	 *   ȕ͕s\łB
	 *
	 * 2){ɃXbhNȏ゠郌X́Aŏ̃N`Ō
	 *   N̒O܂ł̕񂪏Ă܂Bdathtml𐶐ۂ
	 *   gĂꊇup̐K\ŒZvɂȂĂȂƎv܂B
	 *
	 * 3)g_bVu`vU+FF5EAU+301Ci\x{301C}jɌϊĂ܂B
	 *   }CiX@u|vU+FF0DAU+2212i\x{2212}jɌϊĂ܂B
	 *  iɂ邩Ȃ̂ŁA蔭͎QlURLQƂ̂Ɓj
	 *   ҂̕GfB^ŁA炩ߌ҂O҂ɕϊ
	 *   ĂgĂBłȂƕsȕ(UTF-8ł͈Ȃ
	 *   f[^)݂ĂƌȂAG[ďf܂B
	 *  yQlURLzhttp://shain.blog.conextivo.com/2007/07/php_mb_convert_encoding_utf8.html
	 *
	 * 4)dȂǂ̋@ˑĂ܂B
	 *---------------------------------------------------------------*/
	, logmemo : {
		charset : adoEnums.streamCharset.UTF8
		, lineSeparator : adoEnums.lineSeparators.adLF
		//Xbh̔ƃXԍ擾pB1:A2:Xbhԍ
		//<meta property="og:url" content="http://logmemo.org/T[o.2ch.net//Xbhԍ/" />
		, source : {
			name : 'Xbh̔ƃXԍ'
			, pattern : /<meta property="og\:url" content="http\:\/\/logmemo\.org\/[a-z\d]+\.2ch\.net\/([a-z\d]+)\/(\d+)\/" \/>/
			, number : ['$1', '$2'] //ɁAAXbhԍ
		}
		//^CgB1:^CgB<title>`</title>A<h1>`</h1>̒g悤AłOGPtitle擾
		//<meta property="og:title" content="^Cg" />
		, title : {
			name : 'Xbh^Cg'
			, pattern : /<meta property="og\:title" content="([^"]+)" \/>/ //"
			, number : ['$1'] //^Cg
		}
		//X̊JnwB̃p^[XQƌȂB
		//<dl>`
		, resStart : {
			name : 'X̊Jnw'
			, pattern : /<dl>/
		}
		//X̏I[wB̃p^[OXQƌȂB
		//`</dl>
		, resEnd : {
			name : 'X̏Iw'
			, pattern : /<\/dl>/
		}
		//XbhOւ̃Nꊇ폜pimailtoANȊOjB1:IWiURL
		//<a href="/jump?url=http://example.jp" target="_blank">http://example.jp</a>
		, outerLink : {
			pattern : /<a href="\/jump\?url=[^"]+" target="_blank">([^<]+)<\/a>/g //"
			, after : '$1' //IWiURL
		}
		//Xbh̃AJ[ꊇupB$1:JnXԍA$2:-IXԍ
		//uOF<a href="#JnXԍ">&gt;&gt;JnXԍ</a>-IXԍ &gt;̏ꍇ̓AJ[Ȃ
		//uF<a href="../test/read.cgi//Xbhԍ/Xԍ͈" target="_blank">&gt;&gt;Xԍ͈</a>
		, innerLink : {
			pattern : /<a href="#[^"]+">(?:&gt;){2}(\d{1,4})<\/a>(\-\d{1,4})?/g //"
			, after : '\/$1$2" target="_blank">&gt;&gt;$1$2<\/a>' //Xbhԍ܂ł̓vOőgݗĂ̂ŕsv
		}
		//XQ̏ɓÖꊇup
		, beforeResGroup : [
			//O߂̑Xւ̃N폜
			//<a href="/`" target="_blank">URL</a>
			{ pattern : /<a href="\/[^"]+" target="_blank">([^<]+)<\/a>/g, after : '$1' } //"
			//ŏ̃XɊ܂܂XNvg폜iŒZvj
			, { pattern : /<script.*?<\/script>/g, after : '' }
			//ŏ̃XɊ܂܂X|T[hN폜
			//<br /><span style="font-size:10px">[X|T[hN]</span><br />
			, { pattern : /<br \/><span [^>]+>.*?<\/span><br \/>/g, after : '' }
		]
		//Xwb_̑SeB1:<dt></dt>̊Ԃ̓e
		//<dt>`</dt>
		, resHeaderContent : {
			name : 'Xwb_̓e'
			, pattern : /<dt>(.*?)<\/dt>/ //"
			, number : ['$1'] //<dt>`</dt>̊Ԃ̓eidt^Ô͊܂܂Ȃj
		}
		//Xwb_̍זځB1:XԍA2:[a^OA3:[
		//                  4:OAp^[E:tiIDABE܂ށj
		/*
		 	OA[̃p^[͂Ƃ肠ꂾmFiOa{b܂font{bň͂łj
			<a name="99">99</a> : <font color=green><b>O</b></font>: t
			<a name="99">99</a> : <a href="mailto:["><b>O</b></a>: t
			<a name="99">99</a> : <a href="mailto:["><b>O </b>gbv<b></b></a>: t
			<a name="99">99</a> : <a href="mailto:["><b>O </b>gbv <b></b></a>: t
			gbv́̕AOԖڂ̗lԖڂƓlɂȂ悤main.jsŕҏWȂ
		 */
		, resHeaderItem : {
			name : 'Xwb_̍ז'
			, pattern : /<a name="\d+">(\d+)<\/a> : (<a href="mailto:(.*?)">|<font [^>]+>)<b>(.*?)<\/b>(?:<\/a>|<\/font>): /
			, number : ['$1', '$4', '$3', 'rightContext'] //ɁAXԍAOA[At
		}
		//X{
		//<dd> `</dd> <dd>̒ɗ]ɔpXy[X
		, resBody : {
			name : 'X{'
			, pattern : /<dd>\s?(\s.*?)<\/dd>/
			, number : ['$1'] //<dd> `</dd>̊Ԃ̓eidd^Ô͊܂܂Ȃj
		}
	}
	/*---------------------------------------------------------------*
	 * ݂݂񌟍HTMLpp^[
	 *
	 * 2012/9/28݁Aȉ̖̂邱ƂĂ܂B
	 *
	 * 1)gbvzXg̑Oɕt</b>`<b>^O폜
	 *   ܂BŎn܂Έȍ~͑ł͂ȂƂ߂ł܂Ayz
	 *   ͂܂Ă镶zXgȂǂ̓[Uɂ͂ƋʂłA
	 *   ̂܂܉HɎgp邱Ƃɂ܂B
	 *
	 *  ݂݂񌟍ł́Adatt@C_E[hł܂B
	 *    ihttp://mimizun.com/log/2ch//Xԍ.datj
	 *    炩̗RHTMLs\Ƃ̂łȂA
	 *    fdat_E[hĂg܂傤BdatA
	 *    @ˑ͕NĂ̂ŏCKvłB
	 *---------------------------------------------------------------*/
	, mimizun : {
		charset : adoEnums.streamCharset.SJIS
		, lineSeparator : adoEnums.lineSeparators.adLF
		//Xbh̔ƃXԍ擾pB
		//1:A2:Xbhԍ
		//<link rel="alternate" media="handheld" href="/log/2ch//Xbhԍ/" />
		, source : {
			name : 'Xbh̔ƃXԍ'
			, pattern : /<link rel="alternate" media="handheld" href="\/log\/2ch\/([a-z\d]+)\/(\d+)\/" \/>/
			, number : ['$1', '$2'] //ɁAAXbhԍ
		}
		//^CgB1:^CgB<title>`</title>̒g悤Ałdiv擾
		//<div class="threadtitle">^Cg</div>
		, title : {
			name : 'Xbh^Cg'
			, pattern : /<div class="threadtitle">([^<]+)<\/div>/ //"
			, number : ['$1'] //^Cg
		}
		//X̊JnwB̃p^[XQƌȂB
		//eXꂼꂪ<div class="contributor">`</div>ň͂܂Ă邾Ȃ̂Ŗʓ|B
		//  Ȃi݂ȂĂB
		, resStart : {
			name : 'X̊Jnw'
			, pattern : /<body>/
		}
		//X̏I[wB̃p^[OXQƌȂB
		//eX<div class="contributor">`</div>ň͂܂Ă邾Ȃ̂Ŗʓ|B
		//  Ȃi݂ȂĂB
		, resEnd : {
			name : 'X̏Iw'
			, pattern : /<\/body>/
		}
		//XbhOւ̃Nꊇ폜pimailtoANȊOjB1:IWiURL
		//<a href="http://example.jp/">http://example.jp</a>
		, outerLink : {
			pattern : /<a href="(?:http|ftp)[^"]+">([^<]+)<\/a>/g //"
			, after : '$1' //IWiURL
		}
		//Xbh̃AJ[ꊇupB$1:pL(2)A$2:Xԍ͈
		//uOF<a href="#Xԍ͈" class="rlink">&gt;&gt;Xԍ͈</a> &gt;̏ꍇvmF
		//uF<a href="../test/read.cgi//Xbhԍ/Xԍ͈" target="_blank">
		, innerLink : {
			pattern : /<a href="#[^"]+">((?:&gt;){2})((?:\d+)?(?:\-\d+)?)<\/a>/g //"
			, after : '\/$2" target="_blank">$1$2<\/a>' //Xbhԍ܂ł̓vOőgݗĂ̂ŕsv
		}
		//XQ̏ɓÖꊇup
		, beforeResGroup : [
			//<br /><br>ɕϊ
			{ pattern : /<br \/>/g, after : '<br>' }
		]
		//Xwb_̑SeB1:div̊Ԃ̓eiŒZvj
		//<div class="contributor">`</div>
		, resHeaderContent : {
			name : 'Xwb_̓e'
			, pattern : /<div class="contributor">(.*?)<\/div>/ //"
			, number : ['$1'] //<div>`</div>̊Ԃ̓eidiv^Ô͊܂܂Ȃj
		}
		//Xwb_̍זځB1:XԍA2:[a^OA3:[
		//                  4:OAp^[E:tiIDABE܂ށj
		/*
			ɗ܂łɈȉ̌`ɂȂĂ
			<a name="99">99</a> F<span class="handle"><A HREF="mailto:[">O</A></span>Ft
			<a name="99">99</a> F<span class="handle">Ogbv </span>Ft
		 */
		, resHeaderItem : {
			name : 'Xwb_̍ז'
			, pattern : /<a name="\d+">(\d+)<\/a> F<span class="handle">(<A HREF="mailto:(.+?)">)?(.*?)(<\/A>)?<\/span>F/
			, number : ['$1', '$4', '$3', 'rightContext'] //ɁAXԍAOA[At
		}
		//X{iŒZvj
		/*
		 Ӂ
		 {̒PƂ>Adat{̎̎QƂł͂ȂA>ɕϊĂ܂ĂB
		 Pɖ{𒊏o邾łȂA^OȊO>̎QƂɖ߂KvȂ̂ŁAmain.jsőΉB
		 */
		, resBody : {
			name : 'X{'
			, pattern : /<div class="res">(.*?)<\/div>/
			, number : ['$1'] //<div>`</div>̊Ԃ̓eidiv^Ô͊܂܂Ȃj
		}
	}
	/*---------------------------------------------------------------*
	 * QʂHTMLpp^[
	 *
	 * 2012/9/28݁Aȉ̖̂邱ƂĂ܂B
	 *
	 * 1)IWĩX̋LڂɊւ炸A2chւ̃N͕\Lh
	 *   ɂhref̓_CNgɃNȂ̊OTCgւ̃N
	 *   href̓NbVy[WŁA\LhLɕϊĂ炵B
	 *   IWiłURL\LɊւ͎cĂȂ߁Aȕ
	 *   s\łB
	 *---------------------------------------------------------------*/
	, '2chnull' : {
		charset : adoEnums.streamCharset.SJIS
		, lineSeparator : adoEnums.lineSeparators.adLF
		//Xbh̔ƃXԍ擾pBirj[́u1-100ṽN擾Ă݂B
		//1:A2:Xbhԍ
		//<li class="m_top"><a href='/r//Xbhԍ/'>1-100</a></li>
		, source : {
			name : 'Xbh̔ƃXԍ'
			, pattern : /<li class="m_top"><a href='\/r\/([a-z\d]+)\/(\d+)\/'>1\-100<\/a><\/li>/
			, number : ['$1', '$2'] //ɁAAXbhԍ
		}
		//^CgB1:^CgB
		, title : {
			name : 'Xbh^Cg'
			, pattern : /<h1 id="title">([^<]+)/ //"
			, number : ['$1'] //^Cg
		}
		//X̊JnwB̃p^[XQƌȂB
		//SXƗdlȂ̂Ŗʓ|BdlŌɎw肷̂ł͂ȂAOdivŒoĂǂB
		//  Ȃi݂ȂĂB
		//</h1>s<dl id="res1">`
		, resStart : {
			name : 'X̊Jnw'
			, pattern : /<\/h1>/
		}
		//X̏I[wB̃p^[OXQƌȂB
		//SXƗdlȂ̂Ŗʓ|Bdiv̏I^OXQɂ̂ŎgȂB
		//  Ȃi݂ȂĂB
		//<div id="btmnavi">
		, resEnd : {
			name : 'X̏Iw'
			, pattern : /<div id="btmnavi">/
		}
		//XbhOւ̃Nꊇ폜pB1:IWiURL
		//<a href="http://example.jp/"Cӂ̕>http://example.jp</a>
		, outerLink : {
			pattern : /<a href="[^#][^"]+"(?:[^>])*>([^<]+)<\/a>/g //"
			, after : '$1' //IWiURL
		}
		//Xbh̃AJ[ꊇupB$1:pL(2)A$2:X͈͔ԍ
		//uOF<a href="#resXԍ" class="rlink">&gt;&gt;X͈͔ԍ</a> &gt;̏ꍇ̓AJ[Ȃ
		//uF<a href="../test/read.cgi//Xbhԍ/X͈͔ԍ" target="_blank">
		, innerLink : {
			pattern : /<a href="#res[^"]+" class="rlink">((?:&gt;){2})((?:\d+)?(?:\-\d+)?)<\/a>/g //"
			, after : '\/$2" target="_blank">$1$2<\/a>' //Xbhԍ܂ł̓vOőgݗĂ̂ŕsv
		}
		//XQ̏ɓÖꊇup
		, beforeResGroup : [
			//XNvg폜iŒZvj
			{ pattern : /<script.*?<\/script>/g, after : '' }
			//ŏ̃XɂAdiv{iframeň͂܂ꂽLGA폜iŒZvj
			//<div id="ad1"><iframe `</iframe></div>
			, { pattern : /<div id="ad1"><iframe .*?<\/iframe><\/div>/g, after : '' }
			//Xwb_̒ɂ]pimg^O폜
			//<img ` /><br/>
			, { pattern : /<img [^>]+>/g, after : '' }
			//Xwb_̒ɂem^O폜
			, { pattern : /<\/?em>/g, after : '' }
			//Xwb_̃AJ[ɂJavaScriptalert폜
			//<a href='javascript:alert("sage");'>
			, { pattern : /<a href='javascript:alert\("(.*?)"\);'>/g, after : "<a href='$1'>" }
		]
		//Xwb_̑SeB1:<dt></dt>̊Ԃ̓e
		//<dl id="resXԍ"><dt>`</dt>
		, resHeaderContent : {
			name : 'Xwb_̓e'
			, pattern : /<dt>(.*?)<\/dt>/ //"
			, number : ['$1'] //<dt>`</dt>̊Ԃ̓eidt^Ô͊܂܂Ȃj
		}
		//Xwb_̍זځB1:XԍA2:a^OA3:[
		//                  4:OAp^[E:tiIDABE܂ށj
		/*
			ɗ܂łɈȉ̌`ɂȂĂ
				XԍFOFt
				XԍF<a href='['>O</a>Ft
		 */
		, resHeaderItem : {
			name : 'Xwb_̍ז'
			, pattern : /^(\d{1,4})F(<a href='(.*?)'>)?(.*?)(?:<\/a>)?F/
			, number : ['$1', '$4', '$3', 'rightContext'] //ɁAXԍAOA[At
		}
		//X{
		, resBody : {
			name : 'X{'
			, pattern : /<dd>(.*?)<\/dd>/
			, number : ['$1'] //<dd>`</dd>̊Ԃ̓eidd^Ô͊܂܂Ȃj
		}
	}
	/*---------------------------------------------------------------*
	 * OHTMLpp^[
	 *---------------------------------------------------------------*/
	, logsoku : {
		charset : adoEnums.streamCharset.UTF8
		, lineSeparator : adoEnums.lineSeparators.adLF
		//Xbh̔ƃXԍ擾pB1:A2:Xbhԍ
		//<meta property="og:url" content="http://logsoku.com/thread/T[o.2ch.net//Xbhԍ/">
		, source : {
			name : 'Xbh̔ƃXԍ'
			, pattern : /<meta property="og\:url" content="http\:\/\/logsoku\.com\/thread\/[a-z\d]+\.2ch\.net\/([a-z\d]+)\/(\d+)\/">/
			, number : ['$1', '$2'] //ɁAAXbhԍ
		}
		//^CgB1:^CgB<title>`</title>̒g悤Ałmeta^O擾
		, title : {
			name : 'Xbh^Cg'
			, pattern : /<meta property="og:title" content="([^"]+)">/ //"
			, number : ['$1'] //^Cg
		}
		//X̊JnwB̃p^[XQƌȂB
		//<dl class="thread">
		, resStart : {
			name : 'X̊Jnw'
			, pattern : /<dl class="thread">/
		}
		//X̏I[wB̃p^[OXQƌȂB
		//</dl>
		, resEnd : {
			name : 'X̏Iw'
			, pattern : /<\/dl>/
		}
		//XbhOւ̃Nꊇ폜pB1:IWiURL
		//<a href="http://example.jp/"Cӂ̕>http://example.jp</a>
		, outerLink : {
			pattern : /<a href="[^#][^"]+"(?:[^>])*>([^<]+)<\/a>/g //"
			, after : '$1' //IWiURL
		}
		//Xbh̃AJ[ꊇupB$1:pL(2)A$2:X͈͔ԍ
		//uOF<a href="#X͈͔ԍ">&gt;&gt;X͈͔ԍ</a> &gt;̏ꍇ̓AJ[Ȃ
		//uF<a href="../test/read.cgi//Xbhԍ/X͈͔ԍ" target="_blank">
		, innerLink : {
			pattern : /<a href="#[^"]+">((?:&gt;){2})((?:\d+)?(?:\-\d+)?)<\/a>/g //"
			, after : '\/$2" target="_blank">$1$2<\/a>' //Xbhԍ܂ł̓vOőgݗĂ̂ŕsv
		}
		//XQ̏ɓÖꊇup
		/*
		 Ӂ
		 HTMLt@Cɂ郌X{̖̔pXy[X̐ɂĂ1`2ŕsB
		 mȃp^[˂l߂Ȃ̂ŁAȉ͎bIȎwɂȂĂB
		 HTMLł̉{͔pXy[X͏W񂳂邩Ałp̕ss͂ȂƎvB
		 */
		, beforeResGroup : [
			//܂XNvg폜iŒZvj
			{ pattern : /<script.*?<\/script>/g, after : '' }
			//ŏ̃XɊ܂܂Adivň͂܂ꂽLGA폜iŒZvj
			//<br /><div class="ad_area">`</div><br />
			, { pattern : /<br\s?\/><div class="ad_area">.*?<\/div><br\s?\/>/g, after : '' }
			//img^OƁA<br/>폜
			//<img ` /><br/>
			, { pattern : /<img [^>]+ \/><br\s?\/>/g, after : '' }
			//iframe^OƁA<br/>폜
			//<iframe `></iframe><br/>
			, { pattern : /<iframe .*?<\/iframe><br\s?\/>/g, after : '' }
			//eXwb_́u[n/n񔭌]v폜
			, { pattern : /\[\d+\/\d+񔭌\]/g, after : '' }
			//eX{`́u<dd>vu<dd> vɕϊ
			, { pattern : /<dd>/g, after : '<dd> ' }
			//eX{́u<br/></dd>vu <dd>vɕϊ
			, { pattern : /(<br\s?\/>){1,2}<\/dd>/g, after : ' <\/dd>' }
			//ɊeX{u<br\s?/> </dd>vȂu  <dd>vɕϊ
			, { pattern : /<br \/> <\/dd>/g, after : '  <\/dd>' }
			//<br/><br>ɕϊB
			, { pattern : /<br\s?\/>/g, after : '<br>' }
		]
		//Xwb_̑SeB1:<dt></dt>̊Ԃ̓e
		//<dt id="res_header_Xԍ">`</dt>
		, resHeaderContent : {
			name : 'Xwb_̓e'
			, pattern : /<dt [^>]+>(.*?)<\/dt>/ //"
			, number : ['$1'] //<dt>`</dt>̊Ԃ̓eidt^Ô͊܂܂Ȃj
		}
		//Xwb_̍זځB1:XԍA2:a܂b^OA3:[
		//                  4:OAp^[E:tiIDABE܂ށj
		/*
			Xԍ̎
				26 F<a id="999"></a>
		 	OA[̃p^[͂Ƃ肠ꂾmFiOa{b܂span{bň͂łj
				<a href="mailto:sage"><b>O</b></a>F
				<a href="mailto:sage"><b> </b>ygz<b>   </b>y1000~z<b> </b></a>F
				<span style="color:green"><b>O </b>gbv <b></b></span>F
				dat̗
					O </b>gbv <b><><>
					</b>E@yLv=11,xxxPTz<b> <><>
		 */
		, resHeaderItem : {
			name : 'Xwb_̍ז'
			, pattern : /^(\d{1,4}) F<a id="\1"><\/a>(<a href="mailto:(.*?)">|<span [^>]+>)<b>(.*?)<\/b>(?:<\/a>|<\/span>)F/
			, number : ['$1', '$4', '$3', 'rightContext'] //ɁAXԍAOA[At
		}
		//X{
		, resBody : {
			name : 'X{'
			, pattern : /<dd>(.*?)<\/dd>/
			, number : ['$1'] //<dd>`</dd>̊Ԃ̓eidd^Ô͊܂܂Ȃj
		}
	}
	/*---------------------------------------------------------------*
	 * unkarHTMLpp^[
	 *---------------------------------------------------------------*/
	, unkar : {
		charset : adoEnums.streamCharset.UTF8
		, lineSeparator : adoEnums.lineSeparators.adLF
		//Xbh̔ƃXԍ擾pB1:A2:Xbhԍ
		//<meta property="og:url" content="http://unkar.org/r//Xbhԍ">
		, source : {
			name : 'Xbh̔ƃXԍ'
			, pattern : /<meta property="og\:url" content="http\:\/\/unkar\.org\/r\/([a-z\d]+)\/(\d+)">/
			, number : ['$1', '$2'] //ɁAAXbhԍ
		}
		//^CgB1:^CgB<title>`</title>̒g悤Ałh1擾
		, title : {
			name : 'Xbh^Cg'
			, pattern : /<h1>(.+)<\/h1>/
			, number : ['$1'] //^Cg
		}
		//X̊JnwB̃p^[XQƌȂB
		//<dl id="content">
		, resStart : {
			name : 'X̊Jnw'
			, pattern : /<dl id="content">/
		}
		//X̏I[wB̃p^[OXQƌȂB
		//</dl>
		, resEnd : {
			name : 'X̏Iw'
			, pattern : /<\/dl>/
		}
		//XbhOւ̃Nꊇ폜pB1:IWiURL
		//<a href="http://example.jp/"Cӂ̕>http://example.jp</a>
		, outerLink : {
			pattern : /<a href="[^#][^"]+"(?:[^>])*>([^<]+)<\/a>/g //"
			, after : '$1' //IWiURL
		}
		//Xbh̃AJ[ꊇupB$1:pL(2)A$2:X͈͔ԍ
		//uOF<a href="#lXԍ">&gt;&gt;X͈͔ԍ</a> &gt;͈
		//uF<a href="../test/read.cgi//Xbhԍ/X͈͔ԍ" target="_blank">
		, innerLink : {
			pattern : /<a href="#l\d+">((?:&gt;){2})((?:\d+)?(?:\-\d+)?)<\/a>/g //"
			, after : '\/$2" target="_blank">$1$2<\/a>' //Xbhԍ܂ł̓vOőgݗĂ̂ŕsv
		}
		//XQ̏ɓO̒up
		, beforeResGroup : [
			//Xbh̃AJ[(pL1)ꊇ폜pB
			{ pattern : /<a href="#l\d+">(&gt;(\d+)?(\-\d+)?)<\/a>/g, after : '$1' }
			//ŏ̃XɊ܂܂XNvg폜iŒZvj
			, { pattern : /(<div>)?<script.*?<\/script>(<\/div>)?\t?/g, after : '' }
		]
		//Xwb_̑SeB1:<dt></dt>̊Ԃ̓e
		, resHeaderContent : {
			name : 'Xwb_̓e'
			, pattern : /<dt id="l\d+">(.*?)<\/dt>/
			, number : ['$1'] //<dt>`</dt>̊Ԃ̓eidt^Ô͊܂܂Ȃj
		}
		//Xwb_̍זځB1:XԍA2:<b>܂͔p(sgp)A
		//                  3:OA4:</b>܂͔p󔒁A5:mailAp^[E:tiIDABE܂ށj
		/*
		 * OA[̃p^[Ƃ肠ꂾmF
		 * 9 F<span><b>O</b></span>F9999/99/99(j) 00:00:00.00 ID:aaaaaaaa0
		 * 10 F<span><b>O</b></span>[sage]F9999/99/99(j) 00:00:00.00 ID:aaaaaaaa0
		 * 170 F<span><b>O </b>kzRkRnhAW. </span>F9999/99/99(j) 00:00:00.00 ID:aaaaaaaa0
		 * 376 F<span><b>O </b>E@yLv=2,xxxPz </span>F9999/99/99(j) 00:00:00.00 ID:aaaaaaaa0
		 * 717 F<span> E@yLv=13,xxxPTz </span>F9999/99/99(j) 00:00:00.00 ID:aaaaaaaa0
		 * 1001 F<span><b>POOP</b></span>FOver 1000 Thread
			dat
			u </b>E@yLv=13,xxxPTz<b> <><>v
			uO </b>gbv <b><><>v
		 */
		, resHeaderItem : {
			name : 'Xwb_̍ז'
			, pattern : /^(\d{1,4}) F<span>(<b>| )(.*?)(<\/b>| )<\/span>(?:\[(.*?)])?F/
			, number : ['$1', '$3', '$5', 'rightContext', '$2'] //ɁAXԍAOA[AtA<br>
		}
		//X{
		, resBody : {
			name : 'X{'
			, pattern : /<dd id="b(?:\d+)">(.*?)<\/dd>/
			, number : ['$1'] //<dd>`</dd>̊Ԃ̓eidd^Ô͊܂܂Ȃj
		}
	}
	/*---------------------------------------------------------------*
	 * DAT2HTMLō쐬htmlĩp^[̂ЂƂjdatɋtϊB
	 *---------------------------------------------------------------*/
	, dat2html1 : {
		charset : adoEnums.streamCharset.SJIS
		, lineSeparator : adoEnums.lineSeparators.adLF
		//Xbh̔ƃXԍ擾pB1:A2:Xbhԍ
		//<a href="http://T[o.2ch.net/test/read.cgi//Xbhԍ/">̃Xbh</a>
		//<a href="http://T[o.bbspink.com/test/read.cgi//Xbhԍ/">̃Xbh</a>
		, source : {
			name : 'Xbh̔ƃXԍ'
			, pattern : /<a href="http:\/\/[a-z\d]+.(?:2ch\.net|bbspink\.com)\/test\/read\.cgi\/([a-z\d]+)\/(\d+)\/">̃Xbh<\/a>/
			, number : ['$1', '$2'] //ɁAAXbhԍ
		}
		//^CgB1:^CgB
		, title : {
			name : 'Xbh^Cg'
			, pattern : /<title>([^<]+)/ //"
			, number : ['$1'] //^Cg
		}
		//X̊JnwB̃p^[XQƌȂB
		//<dl><dt>`
		, resStart : {
			name : 'X̊Jnw'
			, pattern : /<dl\s?[^>]*?><dt>/
		}
		//X̏I[wB<dd>̏I^OȂ̂ŁAł̍i荞݂͂Ȃ
		//, resEnd : {
		//}
		//XbhOւ̃Nꊇ폜pimailtoANȊOjB1:IWiURL
		//<a href="http://example.jp" target="_blank">http://example.jp</a>
		, outerLink : {
			pattern : /<a href="[^#m][^"]+" target="?_blank"?>([^<]+)<\/a>/g //"
			, after : '$1' //IWiURL
		}
		//Xbh̃AJ[ꊇupB$1:>>Xԍ-IXԍA$2:>A$3:Xԍ͈́A$4:JnXԍA$5:IXԍ
		//uOF<a href="#RJnXԍ">&gt;&gt;Xԍ͈</a> &gt;̏ꍇBSp
		//Xԍ͈͂́A- ŏIꍇ
		//uF<a href="../test/read.cgi//Xbhԍ/Xԍ͈" target="_blank">&gt;&gt;Xԍ͈</a>
		, innerLink : {
			pattern : /<a href="#R[^"]+">((&gt;){2}((\d{1,4})(\-\d{1,4})?))<\/a>/g //"
			, after : '\/$3" target="_blank">$1<\/a>' //Xbhԍ܂ł̓vOőgݗĂ̂ŕsv
		}
		//XQ̏ɓÖꊇup
		, beforeResGroup : [
			//Xbh̃AJ[(pL1)ꊇ폜pB
			{ pattern : /<a href="#R\d+">((&gt;|{1,2})([\dO-X]+)?(\-\d+)?\-?)<\/a>/g, after : '$1' }
		]
		//Xwb_̑SeB1:<dt><dd>̊Ԃ̓e
		//<dt>`<dd>
		, resHeaderContent : {
			name : 'Xwb_̓e'
			, pattern : /(.*?)<dd>/ //"
			, number : ['$1']
		}
		//Xwb_̍זځB1:XԍA2:[a^OA3:[
		//                  4:OAp^[E:tiIDABE܂ށj
		/*
		 	<a name="R99">99</a> OF<font color=green><b>O</b></font> eFt
		 	<a name="R99">99</a> OF<a href="mailto:sage"><b>O</b></a> eFt
		 	<a name="R99">99</a> OF<a href="mailto:sage"><b>O</b></a> Ft
		 	<a name="R99">99</a> OF<a href="mailto:age"><b>O </b></a>Ft

		 */
		, resHeaderItem : {
			name : 'Xwb_̍ז'
			, pattern : /<a name="R\d+">(\d+)<\/a> OF(<a href="mailto:(.*?)">|<font [^>]+>)<b>(.*?)\s?<\/b>(?:<\/a>|<\/font>)\s?(?:e)?F/
			, number : ['$1', '$4', '$3', 'rightContext'] //ɁAXԍAOA[At
		}
		//X{
		//<dd> `<br><br><dt>܂</dl>
		, resBody : {
			name : 'X{'
			, pattern : /\s?(.*?)<br><br>(?:<dt>|<\/dl>)/
			, number : ['$1']
		}
	}
}
