/*********************************************************************
 * [] fileio.js
 * 
 * -------------------------------------------------------------------
 * Copyright(C) 2012 ASANO Sei (http://sei.qee.jp/docs/)
 *********************************************************************/
//o̓Xg[iADODB.Streampj
var inStream  = null;
var outStream = null;
//o̓Xg[̏iADODB.Streampj
function setStreamProperties(stream, type, charset, separator) {
	if (type)		stream.Type = type;
	if (charset)	stream.Charset = charset;
	if (separator)	stream.LineSeparator = separator;
}
function initializeInputStream(type, charset, separator) {
	inStream = new ActiveXObject('ADODB.Stream');
	setStreamProperties(inStream, type, charset, separator);
}
function initializeOutputStream(type, charset, separator) {
	outStream = new ActiveXObject('ADODB.Stream');
	setStreamProperties(outStream, type, charset, separator);
}
/*********************************************************************
 * eLXgt@CǂݍŔzɊi[iADODB.StreamŁj
 * ͗pXg[̐ݒ͂炩ߍsȂĂƁB
 * -------------------------------------------------------------------
 * [] fileName : ̓t@C
 * [߂] eLXgsvfƂz
 *********************************************************************/
function loadFromFileByAdodbStream(fileName) {
	var lines = [];
	try {
		inStream.Open();
		inStream.LoadFromFile(fileName);
		while (!inStream.EOS) {
			lines.push(inStream.ReadText(adoEnums.streamRead.adReadLine));
		}
	} catch(e) {
		totalErrorCount++;
		fileSystem_writeLineLogFile('dat̓ǂݍݎɃG[܂B');
		fileSystem_writeLineLogFileForException(e);
	} finally {
		inStream.Close();
		return lines;
	}
}
/*********************************************************************
 * z̓eeLXgt@CɕۑiADODB.StreamŁj
 * o͗pXg[̐ݒ͂炩ߍsȂĂƁB
 * -------------------------------------------------------------------
 * [] array : eLXgsvfƂĊi[z
 *        fileName : ۑt@C
 * [߂] Ȃ
 *********************************************************************/
function saveToFileByAdodbStream(array, fileName) {
	if (!fileSystem.fso.FileExists(fileName)) fileSystem.fso.CreateTextFile(fileName);
	try {
		outStream.Open();
		for (var i=0 ; i<array.length ; i++) {
			outStream.WriteText(array[i], adoEnums.streamWrite.adWriteLine);
		}
		outStream.SaveToFile(fileName, adoEnums.saveOptions.adSaveCreateOverWrite);
	} catch(e) {
		totalErrorCount++;
		fileSystem_writeLineLogFile('ۑɃG[܂ - ' + fileName);
		fileSystem_writeLineLogFileForException(e);
	} finally {
		outStream.Close();
	}
}
/*********************************************************************
 * z̓eeLXgt@CɕۑiTextStreamŁj
 * -------------------------------------------------------------------
 * [] array : eLXgsvfƂĊi[z
 *        fileName : ۑt@C
 * [߂] Ȃ
 *********************************************************************/
function saveToFileByTextStream(array, fileName) {
	if (!fileSystem.fso.FileExists(fileName)) fileSystem.fso.CreateTextFile(fileName);
	var stream;
	try {
		stream = fileSystem.fso.GetFile(fileName).OpenAsTextStream(
				fileSystem.ioMode.ForWriting,
				fileSystem.ioMode.TristateFalse
		);
		for (var i=0 ; i<array.length ; i++) {
			stream.WriteLine(array[i]);
		}
	} catch(e) {
		totalErrorCount++;
		fileSystem_writeLineLogFile('ۑɃG[܂ - ' + fileName);
		fileSystem_writeLineLogFileForException(e);
	} finally {
		stream.Close();
	}
}
