/*********************************************************************
 * [dat_E[h] main.js
 *
 * 2012-09-22 VK쐬
 * 2012-09-25 ̓t@CŁA擪#̍s𖳎悤ύX
 * -------------------------------------------------------------------
 * Copyright(C) 2012 ASANO Sei (http://sei.qee.jp/docs/)
 *********************************************************************/
fileSystem_startLogFile();

//dat擾ۑp
var xmlHttp = getXMLHTTP();
var stream = new ActiveXObject('ADODB.Stream');
stream.Type = adoEnums.streamType.adTypeBinary; //X|XoCgzŎ擾̂
var re_url = /(https?|ftp):\/\/[-_.!~*\'\(\)a-zA-Z0-9;\/?:\@&=+\$,%#]+/; //'URL̊ȈՐK\

var inputFileNames = getInputFileNames();
//C
try {
	for (var i=0 ; i<inputFileNames.length ; i++) {
		if (i > 0) fileSystem_writeLineLogFile('');
		var fileName = inputFileNames[i];
		fileSystem_writeLineLogFile(fileName);
		var parentPath = fileSystem.fso.GetParentFolderName(fileName);
		var outPath = fileSystem.fso.BuildPath(parentPath, fileSystem.fso.GetBaseName(fileName));
		if (!fileSystem_createFolderInNotExists(outPath)) {
			totalErrorCount++;
			fileSystem_writeLineLogFile('o̓tH_쐬ł܂ł - ' + outPath);
			continue;
		}
		main(fileName, outPath);
	}
} catch(e) {
	totalErrorCount++;
	fileSystem_writeLineLogFileForException(e);
} finally {
	fileSystem_closeLogFile();
}
common_showMsg('I܂'
	+ (totalErrorCount ? 'AG[' + totalErrorCount + '܂B' : 'B')
);
/*********************************************************************
 * ̓t@CƂ̏BsA#Ŏn܂s͖B
 * -------------------------------------------------------------------
 * [] fileName : tpX̓̓t@C
 *        outPath  : o͐tH_̃pX
 * [߂] Ȃ
 *********************************************************************/
function main(fileName, outPath) {
	WScript.Sleep(100);
	var lines = fileSystem_readPlainText(fileName, true);
	var saveFileName = null;
	for (var i=0 ; i<lines.length ; i++) {
		var line = lines[i].trim();
		if (!line) continue; //s͖
		if (line.substr(0,1) == '#') continue; //擪#̍s͖
		var items = line.split('\t');

		//URĽ``FbN
		var url = items[0] = items[0].trim();
		if (!url.match(re_url)) {
			totalErrorCount++;
			fileSystem_writeLineLogFile((i+1) + 'sڂURLł͂܂B');
			continue;
		}
		//ۑpdatt@C擾
		var datName = getDatFileName(items)
		saveFileName = fileSystem.fso.BuildPath(outPath, datName);
		downloadDatFile(url, saveFileName);
	}
}
function getDatFileName(array) {
	//ڂ̗vf΁Â܂datt@CƂĎgpBgqύXȂB
	if (array.length > 1) {
		array[1] = array[1].trim();
		if (array[1]) return array[1]; //g~OĂłȂΕԂ
	}
	//URLt@C𒊏oAgqύXdatt@CƂ
	var url = array[0];
	var datName = null;
	var datName = url.slice(url.lastIndexOf('/') + 1);
	if (datName.indexOf('?')) { //?ȍ~폜
		datName = datName.slice(0, datName.indexOf('?'));
	}
	if (datName) {
		datName = fileSystem_changeExtension(datName, 'dat'); //gqύX
	} else {
		//ołȂꍇ́Aݎdatt@CƂ
		datName = new Date().valueOf() + '.dat';
		fileSystem_writeLineLogFile('datt@C擾łȂ̂ŁA' + datName + 'Ƃĕۑ܂B');
	}
	return datName;
}
function downloadDatFile(url, saveFileName) {
	try {
		xmlHttp.open('GET', url, false); //ʐM
		xmlHttp.send('');
		if ((xmlHttp.Status < 200) || (xmlHttp.Status >= 300)) {
			totalErrorCount++;
			fileSystem_writeLineLogFile('ʐMɃG[܂BHTTPXe[^X=' + xmlHttp.Status);
			return;
		}
		saveToDatFile(xmlHttp.responseBody, saveFileName);
	} catch(e) {
		totalErrorCount++;
		fileSystem_writeLineLogFile('ʐMɃG[܂B');
		fileSystem_writeLineLogFileForException(e);
	}
}
function saveToDatFile(responseBody, filename) {
	try {
		stream.Open();
		stream.Write(responseBody);
		stream.SaveToFile(filename, adoEnums.saveOptions.adSaveCreateOverWrite);
	} catch(e) {
		totalErrorCount++;
		fileSystem_writeLineLogFile('ۑɃG[܂ - ' + filename);
		fileSystem_writeLineLogFileForException(e);
	} finally {
		stream.Close();
	}
}
/*********************************************************************
 * XMLHTTPIuWFNgԂB
 * -------------------------------------------------------------------
 * [] Ȃ
 *        outPath  : o͐tH_̃pX
 * [߂] XMLHTTPIuWFNgB擾łȂnullB
 *********************************************************************/
function getXMLHTTP() {
	var obj = null;
	try {
		obj = new ActiveXObject('MSXML2.XMLHTTP');
	} catch(e) {
		try {
			obj = new ActiveXObject('MSXML.XMLHTTPRequest');
		} catch(e) {
			common_showMsg('XMLHTTPIuWFNg擾ł܂łB\n𒆎~܂B');
			WScript.Quit();
		}
	}
	return obj;
}
